// Read the first word but catch many different types of errors

import java.io.*;
import java.util.*;
public class ReadFirstManyCatch{

  // Read the first word in a file and print it. May throw a
  // FileNotFoundException or a NoSuchElementException if the file to
  // be read is empty of words.
  public static void readFirst(String fileName)
    throws FileNotFoundException, NoSuchElementException
  {
    Scanner f = new Scanner(new File(fileName));
    // Control gets here if the file opened successfully
    System.out.println("Reading first word");
    String word = f.next();
    System.out.printf("First word: %s\n",word);
    f.close();
  }

  // Try to read the first word of the file data.txt and handle
  // different errors in different ways.
  public static void main(String args[]) throws Exception{
    try {
      readFirst("names-ages.txt");
    }
    catch(FileNotFoundException e){
      // Control jumps here if there was a problem
      System.out.println("Error: "+e.getMessage());
    }
    catch(NoSuchElementException e){
      System.out.println("Out of input: "+e.getMessage());
      throw new Exception("How did that happen!");
    }
    catch(Exception e){
      System.out.println("Something unexpected happened...: "+
			 e.getMessage());
    }
  }
}
