// Read the first word using a function; can result in nonlocal
// control flow

import java.io.*;
import java.util.*;
public class ReadFirstNonlocal{

  // Open the named file and attempt to read the first word and print
  // it. May raise exceptions.
  public static void readFirst(String fileName)
    throws FileNotFoundException
  {
    Scanner f = new Scanner(new File(fileName));
    // Control gets here if the file opened successfully
    System.out.println("Reading first word");
    String word = f.next();
    System.out.printf("First word: %s\n",word);
    f.close();
  }

  // Run readFirst on data.txt. Catch FileNotFoundExceptions and
  // handle them.
  public static void main(String args[]) throws Exception{
    try {
      readFirst("names-ages.txt");
    }
    catch(FileNotFoundException e){
      // Control jumps here if there was a problem
      // System.out.println("Error: "+e.getMessage());
      System.out.println("File not found. Pick another file:");
      Scanner s = new Scanner(System.in);
      String fname = s.next();
      readFirst(fname);
    }
  }

}
