// Demonstrate defining a simple exception class and how it may be
// used

// A class representing a naughty word that should not be uttered
class BadWordException extends RuntimeException{
  String word; // The naughty word

  // Make an exception but don't throw it
  public BadWordException(String word){
    this.word = word;
  }

  // Override toString() to include the naughty word
  public String toString(){
    return
      String.format("%s (bad word: %s)",
                    super.toString(),this.word);
  }
}

public class TestAndThrow{

  // Print word on the screen if it is not a naughty word. Raise a
  // BadWordException if the word is naughty.
  public static void sayWord(String w){
    // The naught words that shall not be uttered
    String [] badWords = {"poop","doody","frack"};

    // Check that the given word is not any of the naughty words
    for(String bw : badWords){
      if(bw.equals(w)){
        throw new BadWordException(w); // Raise the exception
      }
    }
    System.out.printf("%s!\n",w); // Otherwise print the nice word
  }

  // Demonstrate how throwing an exception percolates up and ends
  // execution if the exception is not caught
  public static void main(String args[]){
    String [] words = {"snot", "buns", "barf",
                       "doody", "cooties","frack"};
    for(String word : words){
      System.out.printf("Say '%s'\n",word);
      sayWord(word);
      System.out.println("(snicker)");
    }
  }
}
